     
"""GreetingCard - a web-based custom greeting card system

  Written for and owned by 8 Days a week.  

"""
     
__version__='$Revision: 0.2 $'[11:-2]     
     
import sys, re    
from Globals import Persistent     
from Globals import PersistentMapping     
from Globals import HTMLFile ,MessageDialog     
from OFS.ObjectManager import ObjectManager     
from AccessControl.Role import RoleManager     
#from SearchIndex.TextIndex import TextIndex     
from SearchIndex.Index import Index     
from IOBTree import BTree     
from intSet import intSet     
from GreetingCardFile import GreetingCardFile     
from OFS.Folder import Folder    
from Acquisition import Implicit     
from time import time, localtime, strftime, gmtime     
from string import strip,split,join     
from string import lower,rfind,atoi, replace    
from urllib import quote, unquote     
from DocumentTemplate.DT_Util import html_quote    
from OFS.Document import Document     
from OFS.Folder import Folder                 # Cards inherit Folder attributes
from OFS.SimpleItem import SimpleItem         # Recipients inherit simpleitem
from DateTime import DateTime
import os     

##############
##
## PDF generation tools
##
##############

import _imaging
import PIL.Image
from reportlab.pdfgen import canvas       
from reportlab.lib.units import inch, cm
from reportlab.lib import colors
from reportlab.platypus import Paragraph, SimpleDocTemplate, Frame
from reportlab.lib.styles import ParagraphStyle
from reportlab.lib.randomtext import randomText

BASEFONT = ('Times-Roman', 10)

def framePageLandscapeForm(c):
    c.beginForm("frame")
    c.saveState()
    #draw a border
    c.setFillColorRGB(0,0,0.95)
    c.rect(0.3*inch, inch, 0.15*inch, 10*inch, fill=1)
    c.restoreState()
    c.endForm()

def framePagePortraitForm(c):
    c.beginForm("frame")
    c.saveState()
    #draw a border
    c.setFillColorRGB(0,0,0.95)
    c.rect(0.15*inch, inch, 0.15*inch, 6.5*inch, fill=1)
    c.restoreState()
    c.endForm()


titlelist = []

def myFirstPage(canvas, doc):
    """ a page guide for laying out paragraph text """
    canvas.saveState()
    canvas.drawString(108, .5 * inch, "testing paragraph")
    canvas.restoreState()

def myLaterPages(canvas, doc):
    """ a page guide for laying out paragraph text """
    canvas.saveState()
    canvas.drawString(108, .5 * inch, "testing paragraph")
    canvas.restoreState()



def framePageLandscape(canvas, title):
    """To print a landscape card, you need a page setup 
       to portrait.
    """
    titlelist.append(title)
    #canvas._inPage0()
    canvas.saveState()
    canvas.setFont('Times-BoldItalic',10)
    canvas.drawString(inch, 10.75 * inch, title)
    canvas.bookmarkHorizontalAbsolute(title, 10.8*inch)
    #canvas.addOutlineEntry(title+" section", title, level=0,closed=closeit)
    #closeit = not closeit # close every other one
    canvas.setFont('Times-Roman',10)
    canvas.drawCentredString(4.135 * inch, 0.25 * inch,
                            'Page %d' % canvas.getPageNumber())
    canvas.restoreState()
    canvas.doForm("frame")
    
def framePagePortrait(canvas, title):
    titlelist.append(title)
    #canvas._inPage0()
    canvas.saveState()
    canvas.setFont('Times-BoldItalic',10)
    canvas.drawString(inch, 8 * inch, title)
    canvas.bookmarkHorizontalAbsolute(title, 7.525*inch)
    #canvas.addOutlineEntry(title+" section", title, level=0,closed=closeit)
    #closeit = not closeit # close every other one
    canvas.setFont('Times-Roman',10)
    canvas.drawCentredString(5.225 * inch, 0.25 * inch,
                            'Page %d' % canvas.getPageNumber())
    canvas.restoreState()
    canvas.doForm("frame")

def makesubsection(canvas, title, horizontal):
    canvas.bookmarkHorizontalAbsolute(title, horizontal)
    #canvas.addOutlineEntry(title+" subsection", title, level=1)
    newsubsection(title)

# outline helpers
outlinenametree = []
def newsection(name):
    outlinenametree.append(name)

def newsubsection(name):
    from types import TupleType
    thissection = outlinenametree[-1]
    if type(thissection) is not TupleType:
        subsectionlist = []
        thissection = outlinenametree[-1] = (thissection, subsectionlist)
    else:
        (sectionname, subsectionlist) = thissection
    subsectionlist.append(name) 



def drawCropMark(canvas, orientation, x, y):
    """ draw a crop mark.
        canvas reffers to the pdf file that is being created
        orientaion tells us which crop mark to draw:
            TL= Top left
            BL= Bottom Left
            TR= Top Right
            BR= Bottom Right
        x and y are cut (center) location coordiantes
    """
    canvas.saveState()
    canvas.setStrokeColorRGB(0,0,0)
    if orientation == 'TL':
        canvas.line(x-20,y, x-10,y)
        canvas.line(x,y+20,x,y+10)
    elif orientation == 'BL':
        canvas.line(x-20,y,x-10,y)
        canvas.line(x,y-20,x,y-10)
    elif orientation == 'TR':
        canvas.line(x+20,y,x+10,y)
        canvas.line(x,y+20,x,y+10)
    elif orientation == 'BR':
        canvas.line(x+20,y,x+10,y)
        canvas.line(x,y-20,x,y-10)
    canvas.restoreState()


def drawCrossHairs(canvas, x, y):
    """just a marker for checking text metrics - green for speed! """

    canvas.saveState()
    canvas.setStrokeColorRGB(0,1,0)    
    canvas.line(x-6,y,x+6,y)
    canvas.line(x,y-6,x,y+6)
    canvas.restoreState()




CRLF=re.compile('\r\n\|\n\r')    
tagRegex = re.compile("<.*?>")     
    
class Stack:     
    def __init__(self):     
        self.mlist = []     
    def pop(self):     
        data = self.mlist[-1]     
        del self.mlist[-1]     
        return data     
    def push(self,data):     
        self.mlist.append(data)     
    def isEmpty(self):     
        return (len(self.mlist) == 0)     
     
def sameday(n,m):
    n = DateTime(n)
    m = DateTime(m)
    if m.Date()==n.Date():
         return 1
    else:
         return 0
     
def addDTML(obj,id,title,file):     
    f=open('%s/Products/%s.dtml' % (SOFTWARE_HOME,file))     
    file=f.read()     
    f.close()     
    obj.manage_addDTMLMethod(id,title,file)     
    return getattr(obj,id)     
     
def addImage(obj,id,title,file):     
    f=open('%s/Products/%s' % (SOFTWARE_HOME,file),'rb')     
       
    contents=f.read()     
    f.close()     
    title=title    
    tlen = len(contents)     
    new_id = obj.manage_addImage(id,contents,title)   
    img_obj = obj.__getitem__(new_id)  
    img_obj.content_type = 'image/gif'  
    
     
def addTable(obj,id,fname):     
    file=open('%s/Products/%s.tbl' % (SOFTWARE_HOME,fname))     
    cols=file.readline()     
    cols=cols[:-1] # takeout newline     
    delim=file.readline()     
    delim=delim[:-1]     
    fcontent=file.read()     
    file.close()     
    title=''     
    obj.manage_addTinyTable(id,title,delim,cols)     
    tbl=getattr(obj,id)     
    tbl.manage_editData(fcontent)     
     
def addNewTable(obj,id,fname):     
    file=open('%s/Products/%s.tbl' % (SOFTWARE_HOME,fname))     
    cols=file.readline()     
    cols=cols[:-1] # takeout newline     
    fcontent=file.read()     
    file.close()     
    title=''     
    obj.manage_addTinyTable(id,title,cols)     
    tbl=getattr(obj,id)     
    tbl.manage_editData(fcontent)     
     
def addArt(obj,file):     
    f=open('%s/Products/%s' % (SOFTWARE_HOME,file))     
    file=''     
    title = f.readline()[:-1] # removes newline char     
    subject = f.readline()[:-1]     
    author = f.readline()[:-1]     
    email = f.readline()[:-1]     
    notify= f.readline()[:-1]     
    dept=f.readline()[:-1]     
    summary=''     
    currline=f.readline()     
    while strip(currline) <> '%%' and currline <> '':     
        summary = summary + currline     
        currline=f.readline()     
    body=''     
    currline=f.readline()     
    while strip(currline) <> '%%' and currline <> '':     
        body = body + currline     
        currline=f.readline()     
    f.close()     
    
    id =  obj.addPosting(title,author,body,email,notify,file,summary,subject,dept,None,None,1)     
    msg = obj.data[id]     
    msg.reviewed = 1     
    return id     
     
PATH_SEP=re.compile('[\\/]')      
    
def addFile(file, ctype):     
    try:     
        f = open('%s/Products/%s' % (SOFTWARE_HOME,file),'rb')     
    except:     
        return ''     
    sf = Squishfile()     
    sf._file = f.read()     
    f.close()     
    name=strip(PATH_SEP.split(file)[-1])     
    sf._name = name     
    sf._ctype = ctype           
    sf._created = time()     
    sf._modified = sf._created     
    return sf     
    
htmlhead =  '''<html><head><title>%s</title>  
<body><pre>    
'''    
    
htmlend = '''   
</pre></body></html>    
'''    
    
def addText(file,title):    
    global htmlhead, htmlend     
    try:     
        f = open('%s/Products/%s' % (SOFTWARE_HOME,file),'rb')     
    except:     
        return htmlhead + htmlend         
    s = f.read()     
    f.close()     
    return (htmlhead % title) + html_quote(s) + htmlend    
    
##readme = addText('Squishdot/README.txt','Readme')    
##credits = addText('Squishdot/Credits.txt','Credits')    
##license = addText('Squishdot/License.txt','License')    
##changes = addText('Squishdot/Changes.txt','Changes')    
##version = addText('Squishdot/version.txt','Version')    
    
about = '''<html><head><title>About GreetingCard</title></head>     
<body>    
<h3>About GreetingCard</h3>    
<p>    
    
<p>    
<ul>    
<li><a href="Readme">Readme.txt</a>     
<li><a href="Credits">Credits.txt</a>     
<li><a href="License">License.txt</a>     
<li><a href="Changes">Changes.txt</a>     
<li><a href="Version">version.txt</a>     
</ul>    
</body></html>    
'''    
    
class GreetingCardSite(Folder, RoleManager):     
    """ 
    
    This is the base class of the greeting card.
    It provides the functions of keeping track of the cards,
    and all other objects exist within this class.
    
    This class appears on the web (thanks zope) as:
    www.8daw.com:8080/greetingcards/
    
    """     
    meta_type  ='GreetingCard Site'     
    description='GreetingCard Site'     
     
    icon       ='misc_/GreetingCard/greetingcard_img'     
    root       =1     
    ## squishlogo ='misc_/GreetingCard/greetingcardlogo'    
    
    _properties=({'id':'title', 'type':'string','mode':'w'},)     
     
    manage_cards=HTMLFile('GreetingCard_manage_cards', globals())     
    manage_editForm=HTMLFile('GreetingCard_editForm', globals())     
    manage_types=HTMLFile('GreetingCard_manage_types', globals())    
       
    ##About = Document(about, __name__='About')    
    ##Readme = Document(readme, __name__='Readme')    
    ##Credits = Document(credits, __name__='Credits')    
    ##License = Document(license, __name__='License')    
    ##Changes = Document(changes, __name__='Changes')    
    ##Version = Document(version, __name__='Version')    
    ##About.__roles__=None    
    ##Readme.__roles__=None    
    ##Credits.__roles__=None    
    ##License.__roles__=None    
    ##Changes.__roles__=None    
    ##Version.__roles__=None    
    
    manage_options=({'label':'Contents', 'icon':icon,     
                     'action':'manage_main', 'target':'manage_main'},        
                    {'label':'Types', 'icon':'',     
                     'action':'manage_types', 'target':'manage_main'},     
                     {'label':'Options', 'icon':'',     
                     'action':'manage_editForm', 'target':'manage_main'},     
                    {'label':'Properties', 'icon':'',     
                     'action':'manage_propertiesForm', 'target':'manage_main'},     
                    {'label':'Security', 'icon':'',     
                     'action':'manage_access', 'target':'manage_main'},     
                    {'label':'Undo', 'icon':'',     
                     'action':'manage_UndoForm','target':'manage_main'},     
                    )     
     
    __ac_permissions__=Folder.__ac_permissions__+(     
        ('Manage Cards', ['manage_main','manage_edit', 'manage_delete', 'delete_types','add_type',    
                             'manage_cards','manage_editForm','manage_types']),     
        ('Add Cards', ['addCard'], ('Anonymous', 'Manager')),     
        )     
        
        
    def __init__(self, id, title, mhost, exp, moderated, uploadsallowed, max_itemlist):     
        t=time()     
        self.id       = id     
        self.title    = title     
        self.created  = t     
        self.modified = t     
        self.mail_host= mhost     
        self.expire   = exp     
     
        self.moderated= moderated    
        self.uploadsallowed=uploadsallowed
     
        if max_itemlist:     
            self.max_itemlist=max_itemlist     
        else:     
            self.max_itemlist=30     
     
        #self.data     =BTree()  # id -> Message     
        #self.ids      =intSet() # ids of children     

        self.types = PersistentMapping()     
     
        # self.indices=PersistentMapping({'creatorname': Index(),     
        #                                 'title'  : Index(),         
        #                               })     
        # self.subjindexes = PersistentMapping({'insidetext': TextIndex(),})     
                                                 
        # for k in self.indices.keys():     
        #     self.indices[k]._init(self.data,None,k)     
        # for k in self.subjindexes.keys():     
        #     self.subjindexes[k]._init(self.data,None,k)     
     
    
        self.defaultDocFile('validateCard','Validate Card',     
                            'GreetingCard/invalidCard') 
        self.defaultDocFile('validateRecipient','Validate Recipient',     
                            'GreetingCard/invalidRecipient') 


        self.defaultDocFile('showError','Display an error',     
                            'GreetingCard/showError')
        self.defaultDocFile('showMessage','Show Message',     
                            'GreetingCard/showMessage')         
    
        ##newprop = list(self._properties)     
        ##newprop.append({'id':'rss_description', 'type': 'string', 'mode': 'w'})     
        ##newprop.append({'id':'rss_title', 'type': 'string', 'mode': 'w'})     
        ##newprop.append({'id':'rss_image_url', 'type': 'string', 'mode': 'w'})     
    
           
        self.defaultDocFile('mail_html','Email a card',     
                            'GreetingCard/GreetingCard_mail_html')     
        self.defaultDocFile('index_html','GreetingCard Homepage',     
                            'GreetingCard/GreetingCard_index_html')     


        self.defaultDocFile('card_html','Posting',     
                            'GreetingCard/GreetingCard_card_html')     
        self.defaultDocFile('viewCard_html','View a card from within a recipient',     
                            'GreetingCard/viewCard_html')  


        self.defaultDocFile('print_html','Set up a card to print',     
                            'GreetingCard/GreetingCard_print_html')  
        self.defaultDocFile('print_back_html','Set up the back of a card to print',     
                            'GreetingCard/GreetingCard_print_back_html')  


        self.defaultDocFile('Recipient_html','Recipient',     
                            'GreetingCard/GreetingCard_Recipient_html') 

        ##self.defaultDocFile('searchForm','Search Form',     
        ##                    'Squishdot/Squishdot_searchForm')     
        ##self.defaultDocFile('searchResults','Search Results',     
        ##                    'Squishdot/Squishdot_searchResults')     


        self.defaultDocFile('addCardForm','Add Card Form',     
                            'GreetingCard/addCardForm')     
        self.defaultDocFile('previewCard','Preview Card',     
                            'GreetingCard/GreetingCard_previewForm')     
        self.defaultDocFile('viewCardType','View Cards By Type',     
                            'GreetingCard/GreetingCard_viewCardType')  

        self.defaultDocFile('addRecipientForm','Add Recipient Form',     
                            'GreetingCard/addRecipientForm')     


        ##self._properties = tuple(newprop)     
        ##self._updateProperty('rss_image_url','')      

        self.manage_addFolder('Images','Images')     
        self.manage_addFolder('Cards','Cards') 
        self.manage_addFolder('TypeImages','Type Images')     
 
        curr_folder =  getattr(self,'Images')     
        addDTML(curr_folder,'show_gallery','show gallery','GreetingCard/GreetingCard_showGallery')
        addImage(curr_folder,'738H_trim', '738 pixel Horizontal trim marks', 'GreetingCard/Images/738H_trim.gif') 
        addImage(curr_folder,'738V_trim', '738 pixel Vertical trim marks', 'GreetingCard/Images/738V_trim.gif') 
        addImage(curr_folder,'432H_trim', '432 pixel Horizontal trim marks', 'GreetingCard/Images/432H_trim.gif') 
        addImage(curr_folder,'432V_trim', '432 pixel Vertical trim marks', 'GreetingCard/Images/432V_trim.gif') 

        self.Images.manage_addFolder('Textures','Textures')
        curr_folder =  getattr(self,'Images','Textures')
        addDTML(curr_folder,'index_html','gallery index','GreetingCard/GreetingCard_galleryindex_html')
        self.Images.manage_addFolder('Nature','Nature')


        self.Images.Textures.manage_addFolder('Thumbs','Thumbs')
        self.Images.Nature.manage_addFolder('Thumbs','Thumbs')

        #addImage(curr_folder,'rust825.jpg','Rust825','GreetingCard/Images/rust825.jpg')     

        curr_folder =  getattr(self,'TypeImages')     
        # note: build images      
        addImage(curr_folder,'birthday_img', 'Birthday', 'GreetingCard/TypeImages/birthday.gif') 
        addImage(curr_folder,'congradulations_img', 'congradulations', 'GreetingCard/TypeImages/congradulations.gif')
        addImage(curr_folder,'easter_img',  'easter','GreetingCard/TypeImages/easter.gif')      
         
     
        self.add_type('Birthday','TypeImages/birthday_img')   
        self.add_type('Congradulations','TypeImages/congradulations_img') 
        self.add_type('Easter','TypeImages/easter_img')     
        
    
    def __len__(self): return 1     
     
    def __getitem__(self,n):     
        try:    id=atoi(n)     
        except: raise AttributeError, n     
        if self.ids.has_key(id):     
            return self.data[id].__of__(self)     
        raise AttributeError, n     
     
    def dupString(self, dstr, count):     
        ''' returns a duplicate of dstr by count times (should really be a util function)'''     
        return dstr * count     
     
    def has_types(self):     
        ''' returns true if site has types defined'''     
        return len(self.types)     
     
    def type_count(self):     
        ''' gives count of types defined'''     
        return self.has_types()     
     
    def add_type(self,type='', imgurl='', REQUEST=None,RESPONSE=None):     
        """ add a type """     
        if type is None:     
            return MessageDialog(title='Data Missing',     
                                 message='You must enter a type!',     
                                 action=REQUEST['URL1']+'/manage_types',     
                                 target='manage_main'     
                                )     
        self.types[type]= imgurl     
        self._p_changed = 1    
     
        if REQUEST:     
            return self.manage_types(self, REQUEST)     
     
    def delete_types(self,typs=[],REQUEST=None):     
        """ delete a type"""     
        for typ in typs:     
            del self.types[typ]     
        self._p_changed = 1    
        if REQUEST:     
            return self.manage_types(self, REQUEST)     
     
    def types_list(self):     
        ''' lists all types '''    
        types = self.types.keys()    
        types.sort()    
        return types    
     
    def type_image(self,typ):     
        ''' returns an image url associated with the type (can be an empty string)'''     
        if self.types.has_key(typ):     
            return self.types[typ]     
        else:     
            return ''     
     
    def createId(self):     
        id=int(time())     
        while 1:     
            try:    o=self.data[id]     
            except: break     
            id=id+1     
        return id     
     
    def defaultDocFile(self,id,title,file):     
        f=open('%s/Products/%s.dtml' % (SOFTWARE_HOME,file))     
        file=f.read()     
        f.close()     
        self.manage_addDTMLMethod(id,title,file)     
     
    def cardValues(self):     
        """ return list of cards """     
        return self.Cards.objectValues('GreetingCardPost')  
     
    def rev_card_list(self):     
        """ returns reversed id list of reviewed cards  """     
        rlist = self.Cards.objectValues('GreetingCardPost')     
        cardlist=[]
        for i in rlist:
            if getattr(i,'reviewed')!=0:
                if getattr(i,'is_public')!=0:
                    cardlist.append(i)   

        cardlist.reverse()     
        return cardlist     
     
    def cardCount(self):
        """ """
        return len(self.rev_card_list())

    def item_list(self):     
        """ returns latest cards  """                          
        currtime =   int(time())     
        return map(lambda x, p=self: x.__of__(p), self.data.map(self.id_list(currtime)))     
     
    def id_list(self, currtime):     
        ''' returns id list of latest cards at currtime '''     
        rlist = self.rev_id_list()     
        max = self.max_itemlist     
        min = max / 3     
        rlen = len(rlist)     
        if rlen <= min:     
            pass # take all elements     
        else:     
            today_list = self.date_id_list(currtime)  # take only items from today     
            tlen = len(today_list)     
            if tlen <= min:     
                rlist = rlist[:min] # take minimum elements even though some items came from yesterday     
            else:     
                if tlen >= max:     
                    rlist = today_list[:max]  # take maximum elements from today                        
                else:     
                    rlist = today_list # take entire list of items from today     
        return rlist     
             
    def other_id_list(self, currtime):     
        '''returns id list of cards exceeding max but still within current day'''      
        today_list = self.date_id_list(currtime) # take only items from today     
        tlen = len(today_list)     
        curr_list = self.id_list(currtime)  # take items displayed on main page     
        clen = len(curr_list)     
        if tlen > clen:     
            return today_list[clen:]  # return items from today not displayed on main page     
        else:     
            return []     
     
    def other_list(self):     
        """returns cards exceeding max but still within current day"""     
        currtime =   int(time())     
        return map(lambda x,  p=self: x.__of__(p), self.data.map(self.other_id_list(currtime)))     
     
    def date_id_list(self, currtime):     
        """returns list from sameday """     
        rlist = self.rev_card_list()     
        samedaylist=[]
        for i in rlist:
            if hasattr(i, 'date_created'):
                card_date=i.date_created()
                if sameday(card_date, currtime):
                    samedaylist.append(i)
        return samedaylist     
             
    def date_list(self, day=0):     
        """return list from day """     
        currtime = int(time())  - (86400 * day)     
        return map(lambda x,  p=self: x.__of__(p), self.data.map(self.date_id_list(currtime)))     
     
    def site_id_list(self, currtime):     
        """ returns latest id list from currtime  """     
        ilist = self.id_list(currtime)     
        tdict = {}     
        tlist = []     
        ilen = len(ilist)     
        cnt = 0      
        while (cnt < ilen) and (len(tdict) < 5):     
            id = ilist[cnt]     
            item = self.data[id]     
            if tdict.has_key(item.subject):     
                pass     
            else:     
                tdict[item.subject] = id     
                tlist.append(id)     
            cnt = cnt + 1     
     
        return tlist     
     
    def site_item_list(self):     
        """ returns latest cards from today """     
        currtime =   int(time())     
        return map(lambda x, p=self: x.__of__(p), self.data.map(self.site_id_list(currtime)))     
            
     
    def tpId(self):     
        return self.id     
     
    def tpURL(self):     
        return self.id     
     
    def this(self):     
        return self     
     
    def site(self):     
        return (self,)     
     
    def site_url(self):    
        """ url of the GreetingCard main page """ 
        req=self.REQUEST     
        par=req['PARENTS']     
        url=req['URL1']    
        mylist = par[:-1]     
        mystr = ''     
        for p in mylist:     
            if p.meta_type == 'GreetingCard Site':    
                p = rfind(url,mystr)    
                if p >= 0:    
                    urlstr = url[:p]    
                else:    
                    raise "GreetingCard site_url could not compute site_url"    
                return urlstr    
            else:    
                mystr = '/' +  str(p.id) +  mystr     
    
        raise " GreetingCard site_url:could not find site"    
        return ""
        #url = self.REQUEST['URL1']    
        #return url     
     
    def has_items(self):     
        return len(self.ids)     
     
    def item_count(self):     
        return len(self.data)     
     
    def mailhost_list(self):     
        try:    return self.superValues(('Mail Host',))     
        except: return []     
     
    def desc_items(self):     
        """ cards in descending order """     
        mlist = []     
        mstack = Stack()     
        if self.has_items():     
            plist = []     
            for id in self.ids:     
                plist.append(id)     
            plist.reverse()     
            for id in plist:     
                mstack.push(id)     
            while not mstack.isEmpty():     
                item_id = mstack.pop()     
                item = self.data[item_id]     
                mlist.append(item)     
                if item.has_items():     
                    plist = []     
                    for id in item.ids:     
                        plist.append(id)     
                    plist.reverse()     
                    for id in plist:     
                        mstack.push(id)     
                        
        return map((lambda x, p=self: x.__of__(p)), mlist)     
           
    def expire_items(self):     
        """ run to delete cards which are past their expiration (assuming that it has been set)"""     
        if self.expire:     
            d=self.data     
            t=int(time()-(self.expire * 86400.0))     
            ids=[]     
            for id in d.keys():     
                if d[id].modified < t:     
                    ids.append(id)     
            for id in ids:     
                try:    self.delItem(id)     
                except: pass     
        return ''     
     
    def addCard(self,id,title,creatorname,orientation,insidetext='',
                   textcolor='',textfont='',textsize='',imageid='',uploadedimage=None,     
                   type='',is_public=1,REQUEST=None,RESPONSE=None,internal=0):     
        """ add a card """     
        id=str(strip(id))
        title =str(strip(title))    
        creatorname=strip(creatorname)         
        orientation = strip(orientation)     
        textcolor = textcolor
        textfont = textfont
        textsize = textsize
        imageid = imageid
        type = type
        is_public=is_public
        if insidetext:     
            insidetext  =split(CRLF.sub('\n',insidetext),'\n')     
        else:     
            insidetext = None   
             
        reviewed=(not self.moderated) and 1 or 0     
    
        if not internal:     
            message=self.validateCard(REQUEST=REQUEST,title=title,creatorname=creatorname,    
                                        orientation=orientation,insidetext=insidetext,
                                        textcolor=textcolor,imageid=imageid,
                                        uploadedimage=uploadedimage)     
            if message:     
                return self.showError(REQUEST=REQUEST,title='Data Missing',     
                                      message=message,     
                                      action=REQUEST['URL1']+'/previewCard'     
                                     )     
     
        #try:    
        uploadedimage=GreetingCardFile(uploadedimage)     
        #except: uploadedimage=''     
     
        timestamp=self.createId()     
        ob=CardPost(id,title,creatorname,orientation,insidetext,
                     textcolor,textfont,textsize,imageid,uploadedimage,     
                     type,is_public, reviewed)     
        ob.id=str(id)    
        ob.title=title 
        strid=str(id)  
        self.Cards._setObject(strid,ob)   
     
        if REQUEST:     
            p='%s%s' % (REQUEST['SCRIPT_NAME'],REQUEST['PATH_INFO'])     
            sn = REQUEST['SCRIPT_NAME']     
            pi = REQUEST['PATH_INFO']     
            t=self.id     
            p=p[:(rfind(p,t)+len(t))]  + '/'     
            gtime = gmtime(timestamp)     
            glist = list(gtime)     
            glist[0] = glist[0] + 1 # add 1 year to expiry date     
            glist[1] = 12     
            glist[2] = 31     
            glist[3] = 23     
            glist[4] = 59     
            glist[5] = 59     
            glist[6] = 0     
            glist[7] = 365     
            glist[8] = 0     
            gtime = tuple(glist)     
            e = strftime('%A, %d-%b-%y %H:%M:%S GMT',gtime)     
            resp=REQUEST['RESPONSE']     
            #creatorname = quote(creatorname)    
            #resp.setCookie('_suggest_creatorname',creatorname,path=p,expires=e)        
            if self.moderated:     
                p2 = "%s/index_html" % self.site_url()     
            else:     
                p2 = "%s/Cards/%s/index_html" % (self.site_url(),id)     
            return self.showMessage(title='Card Posted',     
                                 message='Your card has been created',     
                                 action=p2     
                                )     
        if internal:     
            return id     
     
    def search(self,REQUEST):     
        """ fulfill a search request """     
        sr=self.__call__(REQUEST,1)     
        rc=len(sr)     
        return self.searchResults(self,REQUEST,search_results=sr,     
                                  result_count=rc)     
     
     
    def manage_edit(self,mailhost='',exp=0,expire='0',moderated='none', uploadsallowed=0,
                    max_itemlist=30,     
                    REQUEST=None):     
        """ edit GreetingCard options  """     
        if exp: expire=atoi(expire)     
        else:   expire=0     
        if mailhost:     
            try:    v=getattr(self, mailhost)     
            except:      
                return MessageDialog(title='Invalid Mail Host',     
                                     message='Cannot find the named mail host!',     
                                     action=REQUEST['URL']+'/manage_main'     
                                    )     
        self.mail_host=mailhost     
        self.expire   =expire   
        self.moderated =moderated
        self.uploadsallowed =uploadsallowed     
     
        if max_itemlist:     
            self.max_itemlist=max_itemlist     
        else:     
            self.max_itemlist=30     
        return self.manage_main(self, REQUEST)     
     
    def manage_delete(self,ids=[],REQUEST=None):     
        """ delete GreetingCard site """     
        ids=map(atoi, ids)     
        while ids:     
            self.delItem(ids[-1])     
            del ids[-1]     
        return self.manage_cards(self, REQUEST)     
     
        

    def suggest_creatorname(self):    
        author = ''    
        try: creatorname = self.REQUEST.cookies['_suggest_creatorname']    
        except: pass    
        if creatorname : creatorname = unquote(creatorname)    
        return creatorname or None    
    

     
class Card(Persistent, Implicit, Folder):     
    """ """     
    manage_editForm=HTMLFile('editCardForm', globals())      
    manage         =manage_editForm     
    #manage_main    =manage_editForm     
    meta_type='GreetingCard'     
    icon   ='misc_/GreetingCard/card_img'     
    root=0     
    
    manage_options = ( 
	{'label': 'Contents', 'icon':icon,
        'action': 'manage_main', 'target':'manage_main'},
      {'label':'Values', 'icon':'',     
        'action':'manage_editForm', 'target':'manage_main'}, 
	{'label': 'View', 'action': ''}, 
	{'label': 'Security', 'action': 'manage_access'},
      {'label':'Undo', 'icon':'','action':'manage_UndoForm','target':'manage_main'},   
        ) 

    def __init__(self, id, title, creatorname,orientation,insidetext,
                   textcolor,textfont,textsize,imageid,uploadedimage,type,
                   is_public, reviewed):     
        self.id      =str(id)            
        self.ids                =intSet()
        self.title   =title     
        self.creatorname  =creatorname     
        self.orientation    =orientation     
        self.insidetext   =insidetext     
        self.textcolor  =textcolor     
        self.textfont  =textfont  
        self.textsize  =textsize  
        self.imageid =imageid    
        self.modified=id   
        self.created=id 
        self.reviewed=reviewed     
        self.type =type         
        self.is_public=is_public
        if uploadedimage:     
            #setattr(self,uploadedimage._name,uploadedimage)     
            self.uploadedimage=uploadedimage     
        else:     
            self.uploadedimage=''     
        #self.revsub  =0     
        #self.reply_cnt =0     
     
    def __len__(self): return 1     
     
    def __getitem__(self,n):     
        try:    id=atoi(n)     
        except: raise AttributeError, n     
        if self.ids.has_key(id):     
            return self.data[id].__of__(self)     
        raise AttributeError, n     
     
    def setItem(self,id,obj):     
        # Make sure the object we store is not wrapped with     
        # an acquisition wrapper, since we will be wrapping     
        # it again manually in __getitem__ when it is needed.     
        if hasattr(obj, 'aq_base'):     
            obj=obj.aq_base     
     
        self.ids.insert(id)     
        self.data[id]=obj     
        # for k in self.indices.keys():     
        #     self.indices[k].index_item(id)     
     
    def dupString(self, dstr, count):     
        return dstr * count     
    
    def striptags(self,s):    
        ''' removes char sequences that invalidate RSS syntax (should really be a util function)'''     
        return tagRegex.sub("",s)    
    
     
    def date_posted(self,fmstr='%A %B %d, @%I:%M%p'):     
        """ date when card was posted """     
        ltime = localtime(self.created)         
        return strftime(fmstr,ltime)     
             
    def cardValues(self):     
        """ return all recipients """     
        return map(lambda x, p=self: x.__of__(p), self.data.map(self.ids))     
     
    def tpId(self):     
        return self.id     
     
    def tpURL(self):     
        return self.id     
     
    def this(self): return self     
         
    def has_items(self):     
        return len(self.ids)     
     
    def sub_ids(self,ids,data):     
        map(ids.insert, self.ids)     
        for item in data.map(self.ids):     
            ids=item.sub_ids(ids,data)     
        return ids     
     
    def desc_items(self):     
        """ return latest list of recipients """     
        mlist = []     
        mstack = Stack()     
        if self.has_items():     
            plist = []     
            for id in self.ids:     
                plist.append(id)     
            plist.reverse()     
            for id in plist:     
                mstack.push(id)     
            while not mstack.isEmpty():     
                item_id = mstack.pop()     
                item = self.data[item_id]     
                mlist.append(item)     
                if item.has_items():     
                    plist = []     
                    for id in item.ids:     
                        plist.append(id)     
                    plist.reverse()     
                    for id in plist:     
                        mstack.push(id)     
        return map((lambda x, p=self: x.__of__(p)), mlist)     
     
    def date_created(self):     
        """ date card was created """     
        t=localtime(self.created)     
        return '%d/%d/%d' % (t[1],t[2],t[0])     
     
    def time_created(self):     
        """ time card was created """     
        t=localtime(self.created)     
        return '%02d:%02d' % (t[3],t[4])     
     
    def attachment(self):     
        """ file attachment """     
        uploadedimage=self.uploadedimage     
        return uploadedimage and (uploadedimage,) or None     
     
    def index_html(self,REQUEST):     
        """ GreetingCard Card main page (the read more page) """    
        return self.card_html(self,REQUEST)     
     
    def doNotify(self, msg, REQUEST):     
        """ sends mail to notify person being replied to """     
        if self.notify and self.email and self.mail_host:     
            mail =self.mail_html(self, REQUEST, newItem=(msg,))     
            mhost=getattr(self,self.mail_host)     
            mhost.send(mail)     
     
    def cancelNotify(self, REQUEST):     
        """ cancels email notification of replies """     
        self.notify=''     
        return self.showMessage(title='Cancelled Notification',     
                             message='You will no longer be notified of replies to this message',     
                             action=self.site_url()     
                            )     
     


    def addRecipient(self,creatorname,sender_name,firstname,lastname,delivery,
                   additional_message='',streetaddress='',city='',state='',
                   zip=None,country='',email='', prefix='',    
                   REQUEST=None,RESPONSE=None):     
        """ add a recipient """     
        prefix=strip(prefix)
        sender_name=strip(sender_name)
        firstname   =strip(firstname)     
        lastname  =strip(lastname)     
        additional_message=strip(additional_message)
        streetaddress   =strip(streetaddress)     
        city    =strip(city)     
        state  =strip(state)
        zip =zip
        country = strip(country)
        email=strip(email)    
     
        message=self.validateRecipient(REQUEST=REQUEST,sender_name=sender_name,
                                  firstname=firstname,lastname=lastname,
                                  delivery=delivery,streetaddress=streetaddress,
                                  city=city,state=state,zip=zip,country=country,email=email)    
     
        if message:    
            return self.showError(REQUEST=REQUEST,title='Data Missing',     
                                 message=message,     
                                 action=REQUEST['URL1'] + '/previewRecipient'     
                                )     
    
  
     
        reviewed=(not self.moderated) and 1 or 0  
        timestamp=self.createId()
        id=str(timestamp)
   
     
        ob=recipientPost(id, creatorname, sender_name,prefix, firstname, lastname, 
                  delivery, additional_message, streetaddress, city, state,     
                  zip, country, email, reviewed)     

        self._setObject(id, ob)     
     
        if REQUEST:     
            try:    self.doNotify(msg,REQUEST)     
            except: pass     
     
            p='%s%s' % (REQUEST['SCRIPT_NAME'],REQUEST['PATH_INFO'])     
            t=self.site()[0].id     
            p=p[:(rfind(p,t)+len(t))]  + '/'      
            gtime = gmtime(timestamp)     
            glist = list(gtime)     
            glist[0] = glist[0] + 1 # add 1 year to expiry date     
            glist[1] = 12     
            glist[2] = 31     
            glist[3] = 23     
            glist[4] = 59     
            glist[5] = 59     
            glist[6] = 0     
            glist[7] = 365     
            glist[8] = 0     
            gtime = tuple(glist)     
            e = 'Friday, 31-Dec-99 23:59:59 GMT'     
            e = strftime('%A, %d-%b-%y %H:%M:%S GMT',gtime)     
            resp=REQUEST['RESPONSE']     
            creatorname = quote(creatorname)    
            resp.setCookie('_suggest_creatorname',creatorname,path=p,expires=e)        
            if self.moderated:     
                p2 = "%s/Cards/%s/index_html" % (self.site_url(),self.id)     
            else:     
                p2 = "%s/Cards/%s/%s/index_html" % (self.site_url(),self.id,id)     
            return self.showMessage(title='Recipient Posted',     
                                 message='Your card recipient has been posted',     
                                 action=p2     
                                )     
     
    def manage_edit(self,title,creatorname,orientation,textcolor,textfont,textsize,
                    imageid='',uploadedimage='',reviewed='',insidetext='', is_public=1,
                    REQUEST=None,RESPONSE=None):     
        """ edit card """     
    
        id = self.id     
        title = strip(title)     
        creatorname=strip(creatorname)         
        orientation = strip(orientation)     
        textcolor = textcolor
        textfont = textfont
        textsize = textsize
        imageid = imageid
        uploadedimage=uploadedimage
        type = type
        if insidetext:     
            insidetext  =split(CRLF.sub('\n',insidetext),'\n')     
        else:     
            insidetext = None   
             
        is_public=is_public

        message=self.validateCard(REQUEST=REQUEST,creatorname=creatorname,
                                  orientation=orientation,insidetext=insidetext,
                                  textcolor=textcolor,imageid=imageid,
                                  uploadedimage=uploadedimage)    
     
        if message:     
            return self.showError(REQUEST=REQUEST,title='Data Missing',     
                                 message=message,     
                                 action=REQUEST['URL1']+'/manage_editForm'     
                                )         
     
        #for index in self.indices.values():               
        #    try:    index.unindex_item(id)     
        #    except: pass     
                     
        self.title =title     
        self.creatorname=creatorname     
        self.orientation =orientation     
        self.textcolor =textcolor
        self.textfont =textfont
        self.textsize =textsize
        self.imageid  =imageid
        self.uploadedimage=uploadedimage     
        self.type=type
        self.is_public=is_public
     
        #for index in self.indices.values():               
        #    try:    index.index_item(id)     
        #    except: pass     
     
     
        if self.moderated and (not self.reviewed) and reviewed:     
            self.reviewed=1     
            #for t in self.thread:     
            #    obj=self.data[t]     
            #    if obj.revsub > 0: obj.revsub=obj.revsub-1     
            #    obj.reply_cnt = obj.reply_cnt+1     
     
        if RESPONSE:     
            RESPONSE.redirect('%s/manage_cards' % self.site_url())     
     


class recipient(Persistent, Implicit, SimpleItem):     
    """ """     
    manage_editForm=HTMLFile('editRecipientForm', globals())      
    manage         =manage_editForm     
    #manage_main    =manage_editForm     
    meta_type='GreetingCardRecipient'     
    icon   ='misc_/GreetingCard/recipient_img'     
    root=0     


    manage_options = ( 
	{'label': 'Contents', 'icon':icon,
        'action': 'manage_main', 'target':'manage_main'},
      {'label':'Values', 'icon':'',     
        'action':'manage_editForm', 'target':'manage_main'}, 
	{'label': 'View', 'action': ''}, 
	{'label': 'Security', 'action': 'manage_access'},
      {'label':'Undo', 'icon':'','action':'manage_UndoForm','target':'manage_main'},   
        ) 
    
    def __init__(self, id, creatorname, sender_name, prefix, firstname, lastname,
                  delivery, additional_message, streetaddress, city, state,     
                  zip, country, email,reviewed):     
        self.id      =str(id)             
        self.creatorname  =creatorname
        self.sender_name=sender_name
        self.prefix    =prefix     
        self.firstname   =firstname     
        self.lastname  =lastname     
        self.delivery  =delivery  
        self.additional_message=additional_message
        self.streetaddress  =streetaddress  
        self.city =city    
        self.state=state   
        self.zip=zip 
        self.country=country     
        self.email =email         
        self.reviewed =reviewed    

        #self.revsub  =0     
        #self.reply_cnt =0     


    def __len__(self): return 1     
     
    def __getitem__(self,n):     
        try:    id=atoi(n)     
        except: raise AttributeError, n     
        if self.ids.has_key(id):     
            return self.data[id].__of__(self)     
        raise AttributeError, n     
     
    def setItem(self,id,obj):     
        # Make sure the object we store is not wrapped with     
        # an acquisition wrapper, since we will be wrapping     
        # it again manually in __getitem__ when it is needed.     
        if hasattr(obj, 'aq_base'):     
            obj=obj.aq_base     
     
        self.ids.insert(id)     
        self.data[id]=obj     
        for k in self.indices.keys():     
            self.indices[k].index_item(id)     
     
    def dupString(self, dstr, count):     
        return dstr * count     
    
    def striptags(self,s):    
        ''' removes char sequences that invalidate RSS syntax (should really be a util function)'''     
        return tagRegex.sub("",s)    
    
     
    def date_posted(self,fmstr='%A %B %d, @%I:%M%p'):     
        """ date when card was posted """     
        ltime = localtime(self.created)         
        return strftime(fmstr,ltime)     
             
    def recipientValues(self):     
        """ return all recipients """     
        return map(lambda x, p=self: x.__of__(p), self.data.map(self.ids))     
     
    def tpId(self):     
        return self.id     
     
    def tpURL(self):     
        return self.id     
     
    def this(self): return self     
         
    def has_items(self):     
        return len(self.ids)     
     
    def sub_ids(self,ids,data):     
        map(ids.insert, self.ids)     
        for item in data.map(self.ids):     
            ids=item.sub_ids(ids,data)     
        return ids     
     
    def desc_items(self):     
        """ return latest list of recipients """     
        mlist = []     
        mstack = Stack()     
        if self.has_items():     
            plist = []     
            for id in self.ids:     
                plist.append(id)     
            plist.reverse()     
            for id in plist:     
                mstack.push(id)     
            while not mstack.isEmpty():     
                item_id = mstack.pop()     
                item = self.data[item_id]     
                mlist.append(item)     
                if item.has_items():     
                    plist = []     
                    for id in item.ids:     
                        plist.append(id)     
                    plist.reverse()     
                    for id in plist:     
                        mstack.push(id)     
        return map((lambda x, p=self: x.__of__(p)), mlist)     
     
    def date_created(self):     
        """ date card was created """     
        t=localtime(self.created)     
        return '%d/%d/%d' % (t[1],t[2],t[0])     
     
    def time_created(self):     
        """ time card was created """     
        t=localtime(self.created)     
        return '%02d:%02d' % (t[3],t[4])       
     
    def index_html(self,REQUEST):     
        """ GreetingCard Card main page (the read more page) """    
        return self.Recipient_html(self,REQUEST)     
     
    def doEmailCard(self, msg, REQUEST):     
        """ sends mail to a card recipient """     
        if self.delivery == 'email' and self.email and self.mail_host:     
            mail =self.mail_html(self, REQUEST, newItem=(msg,))     
            mhost=getattr(self,self.mail_host)     
            mhost.send(mail)     

     
    def manage_edit(self,creatorname, sender_name, firstname,lastname,delivery,
                   additional_message='', streetaddress='',city='',state='',
                   zip=None,country='',email='', prefix='',  
                    REQUEST=None,RESPONSE=None):     
        """ edit card """     
    
        id = self.id     
        creatorname = strip(creatorname)
        sender_name=strip(sender_name)
        firstname=strip(firstname)         
        lastname = strip(lastname)     
        delivery = delivery
        additional_message=strip(additional_message)
        streetaddress = strip(streetaddress)
        city = strip(city)
        state = strip(state)
        zip = zip
        country=strip(country)
        email = strip(email)
        prefix = strip(prefix) 
             
        message=self.validateRecipient(REQUEST=REQUEST,sender_name=sender_name,
                                  firstname=firstname,lastname=lastname,
                                  delivery=delivery,streetaddress=streetaddress,
                                  city=city,state=state,zip=zip,country=country,email=email)    
     
        if message:     
            return self.showError(REQUEST=REQUEST,title='Data Missing',     
                                 message=message,     
                                 action=REQUEST['URL1']+'/manage_editForm'     
                                )         
     
        #for index in self.indices.values():               
        #    try:    index.unindex_item(id)     
        #    except: pass     
            
        self.creatorname  =creatorname     
        self.sender_name=sender_name
        self.prefix    =prefix     
        self.firstname   =firstname     
        self.lastname  =lastname     
        self.delivery  =delivery  
        self.additional_message=additional_message
        self.streetaddress  =streetaddress  
        self.city =city    
        self.state=state   
        self.zip=zip 
        self.country=country     
        self.email =email              
     
        #for index in self.indices.values():               
        #    try:    index.index_item(id)     
        #    except: pass     
     

        if RESPONSE:     
            RESPONSE.redirect('%s/manage_recipients' % self.site_url())     
     




class CardPost(Card):     
    """ """     
    meta_type  ='GreetingCardPost'     
    icon   ='misc_/GreetingCard/card_img'     
    def __init__(self, id, title, creatorname,orientation,insidetext,
                   textcolor,textfont,textsize,imageid,uploadedimage,type,is_public,reviewed ):     
        Card.__init__(self,id, title, creatorname,orientation,insidetext,
                   textcolor,textfont,textsize,imageid,uploadedimage,type,is_public,reviewed)     
        #self.insidetext = insidetext     
        #self.creatorname = creatorname     

    def makeCardPDF(self):
        """ make a pdf card setup to print """
	
        pdffilename=str(self.title + '.pdf')
        
        ## Convert HTML font name to reportlab font name
        
        if self.textfont == 'Arial, Helvetica, sans-serif':
            reportlabfont='Helvetica-Bold'
        elif self.textfont == 'Times, serif':
            reportlabfont='Times-Roman'
        elif self.textfont == 'Comic Sans, cursive':
            reportlabfont='Comic-Sans'
        elif self.textfont == 'Courier, monospace':
            reportlabfont='Courier-Bold'
        else:
            reportlabfont == 'Symbol'

        ## Create point size approximations for HTML font sizes

        reportlabfontsize=int(self.textsize * 2)


        flowablecardtext=[] ## create text container
        ## assign local variable
        reportlabcardtext=join(self.insidetext, '\n')

        ## Create a Style sheet

        sty=ParagraphStyle('normal')
        sty.fontName=reportlabfont
        sty.fontSize=reportlabfontsize
        sty.leading=reportlabfontsize+2
        #cardtextcolor=str(self.textcolor)
        #sty.textColor="red"
        # sty.alignment='CENTER'
        
        para = Paragraph(reportlabcardtext,sty)

        ##  Setup the docuemnt for paragraph text.

        #template = SimpleDocTemplate('test_paragraphs.pdf', showBoundary=1)
        #template.build(cardparagraphtext, onFirstPage=myFirstPage,onLaterPages=myLaterPages)

        os.chdir('/usr/local/zope/localfiles/greetingcardImages/')
        
    
        if self.orientation=='landscape':   
        
        
            # Reportlab uses portrait 
            #  paper setup by default, which is what we need 
            #  to print landscape cards.  We don't need to do
            #  anything special
            
            c = canvas.Canvas(pdffilename)
            framePageLandscapeForm(c) # define the frame form

            framePageLandscape(c, '8DAW GreetingCard - landscape - front')
        
            t = c.beginText(inch, 10*inch)
            t.setFont(reportlabfont, 10)
            #drawCrossHairs(c, t.getX(),t.getY())
            #t.textLines("""This card built and printed online.""")

            uploadedfile = str(self.uploadedimage.file_name())
            c.drawInlineImage(uploadedfile,1.25*inch,1.25*inch,width=5.75*inch,height=4*inch)

            os.chdir('/usr/local/zope/greetingcardLogos/')
            c.drawInlineImage('upsideownlogo.jpg', 3.5*inch, 9.5*inch,width=1.71*inch, height=.72*inch)

       
            drawCropMark(c, 'BL',.75*inch, .5*inch)
            drawCropMark(c, 'TL',.75*inch, 10.5*inch)
            drawCropMark(c, 'BR',7.75*inch, .5*inch)
            drawCropMark(c, 'TR',7.75*inch, 10.5*inch)

            c.showPage()
            framePageLandscape(c, '8daw GreetingCard - landscape - back')


            drawCropMark(c, 'BL',.75*inch, .5*inch)
            drawCropMark(c, 'TL',.75*inch, 10.5*inch)
            drawCropMark(c, 'BR',7.75*inch, .5*inch)
            drawCropMark(c, 'TR',7.75*inch, 10.5*inch)
         
            insidetextframe=layout.SimpleFrame(c, inch,5.75*inch,3*inch,5*inch)
            insidetextframe.addFromList(flowablecardtext)

        elif self.orientation=='portrait':
            
            #  Reportlab uses portrait 
            #  paper setup by default, we switch it with this:
            
            c = canvas.Canvas(pdffilename, pagesize=(841.89,595.27))

            framePagePortraitForm(c) # define the frame form

            framePagePortrait(c, '8DAW GreetingCard - landscape - front')
        
            uploadedfile = str(self.uploadedimage.file_name())
            c.drawInlineImage(uploadedfile,6*inch,1.25*inch,width=4*inch,height=5.75*inch)

            os.chdir('/usr/local/zope/greetingcardLogos/')
            c.drawInlineImage('rightsideuplogo.jpg',2.25*inch,1.25*inch,width=1.71*inch,height=.72*inch)

       
            drawCropMark(c, 'BL',.5*inch, .75*inch)
            drawCropMark(c, 'TL',.5*inch, 7.75*inch)
            drawCropMark(c, 'BR',10.5*inch, .75*inch)
            drawCropMark(c, 'TR',10.5*inch, 7.75*inch)

            c.showPage() # End page one.  Begin Page Two
            framePagePortrait(c, '8daw GreetingCard - landscape - back')


            drawCropMark(c, 'BL',.5*inch, .75*inch)
            drawCropMark(c, 'TL',.5*inch, 7.75*inch)
            drawCropMark(c, 'BR',10.5*inch, .75*inch)
            drawCropMark(c, 'TR',10.5*inch, 7.75*inch)

            (w,h) = para.wrap(4*inch, 4*inch)
            para.drawOn(c, 6*inch, 4*inch)

            #c.rect(6 * inch, 4 * inch, 3 * inch, 4 * inch)
#            textframe = Frame(6 * inch, 4* inch, 3 * inch, 4 * inch)
#            textframe.showBoundary = 1
#            textframe.addFromList(cardparagraphtext, c)

#            t=c.beginText(1*inch, 1*inch)
#            t.textOut(cardparagraphtext)
#            c.drawText(t)

#           insidetextframe=layout.SimpleFrame(c,inch,5.75*inch,3*inch,5*inch)
#            insidetextframe.add(p)
            
#            p.drawOn(c,inch,inch)


            #mark the cursor where it stopped



        os.chdir('/usr/local/zope/greetingcardPDFs/') # save to this directory


            
        c.showPage()
        c.save()
        return "pdf created"


             
    def manage_edit(self,title,creatorname,orientation,insidetext='',textcolor='BLACK',
                    textfont='',textsize='',imageid='',uploadedimage='', type='', 
                    is_public=1, reviewed=0,   
                    REQUEST=None,RESPONSE=None):     
        """ edit an article """     
        title =strip(title)     
        creatorname=strip(creatorname)     
        orientation =strip(orientation)     
        insidetext =insidetext    
   
        textcolor=textcolor
        textfont=textfont
        textsize=int(textsize)
        imageid=imageid
        reviewed=reviewed
        type=type 
        is_public=is_public
    
        message=self.validateCard(REQUEST=REQUEST,title=title,creatorname=creatorname,    
                                     orientation=orientation)    
    
        if message:     
            return self.showError(REQUEST=REQUEST,title='Data Missing',     
                                 message=message,     
                                 action=REQUEST['URL1']+'/manage_editForm'     
                                )     
        id = self.id     
        insidetext  =split(CRLF.sub('\n',insidetext),'\n')          
     
     
        self.title   =title     
        self.creatorname  =creatorname     
        self.orientation    =orientation     
        self.insidetext   =insidetext     
        self.textcolor  =textcolor     
        self.textfont   =textfont
        self.textsize   =textsize
        self.imageid =imageid        
        self.type =type             
        self.is_public=is_public


     
        if self.moderated and (not self.reviewed) and reviewed:     
            self.reviewed=1     
            ##for t in self.thread:     
            ##    obj=self.data[t]     
            ##    if obj.revsub > 0: obj.revsub=obj.revsub-1     
            ##    obj.reply_cnt = obj.reply_cnt+1     
     
        if RESPONSE:     
            RESPONSE.redirect('%s/Cards/manage_main' % self.site_url())     
     
     
    def prev_item(self):     
        """ return previous id in the item list"""     
        parent = self.site()[0]     
        currtime = int(time())     
        rlist = list(parent.id_list(currtime))     
        currpos = 0     
        try:     
            currpos = rlist.index(int(self.id))     
        except:     
            currpos = -1     
        if (currpos == 0) or (currpos < 0):     
            return None     
        else:     
            previd = rlist[currpos - 1]     
            obj = self.data[previd]     
            return (obj.__of__(self),)     
     
    def next_item(self):     
        """ return next id in the item list """     
        parent = self.site()[0]     
        currtime = int(time())     
        rlist = list(parent.id_list(currtime))     
        currpos = 0     
        try:     
            currpos = rlist.index(int(self.id))     
        except:     
            currpos = -1     
        lastpos = len(rlist) - 1     
        if (currpos == lastpos) or (currpos < 0):     
            return None     
        else:     
            nextid = rlist[currpos + 1]     
            obj = self.data[nextid]     
            return (obj.__of__(self),)     
     


class recipientPost(recipient):     
    """ """     
    meta_type  ='GreetingCardRecipientPost'     
    icon   ='misc_/GreetingCard/recipient_img'     
    def __init__(self, id, creatorname,sender_name, prefix, firstname, lastname, 
                  delivery, additional_message,streetaddress, city, state,     
                  zip, country, email, reviewed):     
        recipient.__init__(self,id, creatorname, sender_name, prefix, firstname, lastname, delivery, 
                  additional_message, streetaddress, city, state,     
                  zip, country, email, reviewed)         
             
    def manage_edit(self,creatorname,sender_name,firstname,lastname,delivery,
                   additional_message='',streetaddress='',city='',state='',
                   zip=None,country='',email='', prefix='', reviewed='',
                   REQUEST=None,RESPONSE=None):     
        """ edit a recipient """     
   
        creatorname=strip(creatorname)
        sender_name=strip(sender_name)
        firstname =strip(firstname)     
        lastname =strip(lastname)    
        delivery=delivery
        additional_message=strip(additional_message)
        streetaddress=strip(streetaddress)
        city=strip(city)
        state=strip(state)
        zip=zip
        country=strip(country)
        email=strip(email)
        prefix=strip(prefix) 
        reviewed=reviewed
    
        message=self.validateRecipient(REQUEST=REQUEST,sender_name=sender_name,
                                  firstname=firstname,lastname=lastname,
                                  delivery=delivery,streetaddress=streetaddress,
                                  city=city,state=state,zip=zip,country=country,email=email)     
    
        if message:     
            return self.showError(REQUEST=REQUEST,title='Data Missing',     
                                 message=message,     
                                 action=REQUEST['URL1']+'/manage_editForm'     
                                )     
        id = self.id            
     
        #for index in self.indices.values():                 
        #    try:    index.unindex_item(id)     
        #    except: pass                     
     
        self.creatorname   =creatorname
        self.sender_name =sender_name
        self.firstname  =firstname     
        self.lastname    =lastname     
        self.delivery   =delivery
        self.additional_message=additional_message
        self.streetaddress  =streetaddress     
        self.city =city        
        self.state =state 
        self.zip  =zip
        self.country=country
        self.email=email
        self.prefix=prefix
        self.reviewed=reviewed
    
        #for index in self.indices.values():     
        #    try:    index.index_item(id)     
        #    except: pass     

 
     
        if RESPONSE:     
            RESPONSE.redirect('%s/manage_recipients' % self.site_url())     



     
def manage_addGreetingCardSite(self,id,title='',mailhost='',exp=0,expire='0',     
                              moderated=0, max_itemlist=30,uploadsallowed=0, REQUEST=None):     
    """Create Greetingcard Site"""     
    if exp:     
        try:    expire=atoi(expire)     
        except: expire=0     
    else:   expire=0     
    if mailhost:     
        try:    v=getattr(self, mailhost)     
        except: return MessageDialog(title='Invalid Mail Host',     
                                     message='Cannot find the named mail host!',     
                                     action=REQUEST['URL1']+'/manage_main'     
                                    )     
    ob=GreetingCardSite(id, title, mailhost, expire, moderated, max_itemlist,
                        uploadsallowed)         
    self._setObject(id, ob)     
     
    if REQUEST: return self.manage_main(self,REQUEST,update_menu=1)  
