
"""GreetingCardFile objects"""
  
__version__='$Revision: 0.0.1 $'[11:-2]  
  
import string, time, re  
from Globals import Persistent  
from Acquisition import Acquirer  
from Globals import HTML  
from ImageFile import ImageFile  
  
sep=re.compile('\\\\|/|:')  # handle windows(\)/unix(/)/mac(:) path separators  
  
class GreetingCardFile(Acquirer,Persistent):  
    """ """  
    icon='misc_/GreetingCard/greetingcardfile_img'  
  
    _types={'application/octet-stream':     'Binary File',  
            'application/x-gzip' :          'Compressed File',  
            'application/x-compress':       'Compressed File',  
            'application/x-zip-compressed': 'Compressed File',  
            'audio/basic':     'Audio File',  
            'audio/x-aiff':    'Audio File',  
            'audio/x-wav' :    'Audio File',  
            'text/html':       'HTML Document',  
            'text/asp':        'Active Server Document',  
            'text/plain':      'Text Document',  
            'image/x-ms-bmp':  'Bitmap Image',  
            'image/bmp' :      'Bitmap Image',  
            'image/gif' :      'GIF Image',  
            'image/jpeg':      'JPEG Image',  
            'image/x-png':     'PNG Image',  
            'image/x-tiff':    'TIFF Image',  
            'video/x-msvideo': 'Video File',  
            'video/mpeg':      'Video File',  
            'video/quicktime': 'Video File',  
          }  
  
    def __init__(self,file=''):  
        if file:  
            self._file    =file.read()  
            #spew('sqf len: ' + str(len(self._file)))  
            name=string.strip(sep.split(file.filename)[-1])  
            name=string.split(name, ' ')  
            name=string.join(name, '_')  
            self._name=name  
            #spew('sqf name: ' + self._name)  
            self._ctype   =string.strip(file.headers['content-type'])  
            #spew('sqf ctype: ' + self._ctype)  
            self._created =time.time()  
            self._modified=self._created  
  
    def content_type(self):  
        """ content type """  
        return self._ctype  
  
    def file_name(self):  
        return self._name  
  
    def file_bytes(self):  
        return len(self._file)  
  
    def file_kbytes(self):  
        return int(len(self._file)/1024)  
  
    def file_type(self):  
        try:    return self._types[self._ctype]  
        except KeyError:  
            f=self._name  
            return '%s File' % string.upper(f[(string.rfind('.', f)+1):])  

    def file_data(self):
        return self._file
  
    def date_created(self):  
        t=time.localtime(self._created)  
        return '%d/%d/%d %02d:%02d' % (t[1],t[2],t[0],t[3],t[4])  
  
    def date_modified(self):  
        t=time.localtime(self._modified)  
        return '%d/%d/%d %02d:%02d' % (t[1],t[2],t[0],t[3],t[4])  
  
    def __len__(self):  
        try:    return len(self._file)  
        except: return 0 # _file doesnt exist  
  
    def __repr__(self, RESPONSE={}):  
        """ """  
        RESPONSE['content-type']=self._ctype  
        return self._file  
  
    index_html=__repr__  
